<?php
function weblogUpdates_ping($blog_title, $blog_url, $rpc_host, $rpc_page='/', $rpc_port='80')
{
	$xml_rpc = '<?xml version="1.0" encoding="utf-8"?>'."\r\n";
	$xml_rpc .= '<methodCall>'."\r\n";
	$xml_rpc .= '	<methodName>weblogUpdates.ping</methodName>'."\r\n";
	$xml_rpc .= '	<params>'."\r\n";
	$xml_rpc .= '		<param>'."\r\n";
	$xml_rpc .= '			<value>'.$blog_title.'</value>'."\r\n";
	$xml_rpc .= '		</param>'."\r\n";
	$xml_rpc .= '		<param>'."\r\n";
	$xml_rpc .= '			<value>'.$blog_url.'</value>'."\r\n";
	$xml_rpc .= '		</param>'."\r\n";
	$xml_rpc .= '	</params>'."\r\n";
	$xml_rpc .= '</methodCall>'."\r\n";

	$xml_rpc_length = strlen($xml_rpc);

	$http_request = 'POST '.$rpc_page.' HTTP/1.0'."\r\n";
	$http_request .= 'User-Agent: sebastienguillon.com'."\r\n";
	$http_request .= 'Host: '.$rpc_host."\r\n";
	$http_request .= 'Content-Type: text/xml'."\r\n";
	$http_request .= 'Content-length: '.$xml_rpc_length."\r\n\r\n";
	$http_request .= $xml_rpc."\r\n";
	
	/* Décommentez la ligne suivante pour afficher la requête XML-RPC */
	//echo '<p>Requête XML-RPC :</p><pre>'.htmlentities($http_request).'</pre>';

	$theSock = fsockopen($rpc_host, $rpc_port);
	if($theSock)
	{
		fwrite($theSock,$http_request);
		stream_set_blocking($theSock,1);

		while(!feof($theSock))
		{
			$buf .= fgets($theSock,128);
		}
		fclose($theSock);
		/* Décommentez la ligne suivante pour afficher la réponse à la requête XML-RPC */
		//echo '<p>Réponse XML-RPC :</p>'."\r\n\r\n".'<pre>'.htmlentities($buf).'</pre>';
	}
}

// Exemples d'utilisation de la fonction weblogUpdates_ping
weblogUpdates_ping('Sébastien Guillon', 'http://sebastienguillon.com/journal', 'rpc.pingomatic.com');
weblogUpdates_Ping('Sébastien Guillon', 'http://sebastienguillon.com/journal', 'rpc.weblogs.com', '/RPC2');
?>